CPU 8086
ORG 0

%define SECPERHEAD 8
%define NUMHEADS 2

%define DESTINATIONSEG 1000h
%define DESTINATIONOFS 0100h

%define CYLINDER(lbs) ((lbs) / ((SECPERHEAD) * (NUMHEADS)))
%define HEAD(lbs) ((lbs) / (SECPERHEAD) % (NUMHEADS))
%define SECTOR(lbs) ((lbs) % (SECPERHEAD) + 1)

entrypoint:
  jmp short label_0000001e

db 00h, 00h

data_00000004:
db 00h
data_00000005:
db 00h
data_00000006:
db 00h
data_00000007:
dw 0000h

db 3 dup (00h), 04h, 01h, 01h, 00h, 02h, 0c0h, 00h, 0d0h, 04h, 0feh, 02h, 00h, 08h, 00h, 02h, 00h, 00h, 00h

label_0000001e:
  mov ax, DESTINATIONSEG
  mov es, ax
  mov ax, cs
  add ax, 0010h
  mov ds, ax
  mov byte [data_00000004], CYLINDER(COMSECTOR)
  mov byte [data_00000005], HEAD(COMSECTOR)
  mov byte [data_00000006], SECTOR(COMSECTOR) 
  mov word [data_00000007], 0000h
label_0000003f:
  mov ah, 56h
  mov al, 90h ; device address number (floppy)
  mov bx, 0400h ; 1024 bytes (one sector) at a time
  mov cl, [data_00000004]
  mov ch, 03h ; 1 << 3, 8 sectors
  mov dl, [data_00000006]
  mov dh, [data_00000005]
  mov bp, DESTINATIONOFS
  int 1bh
  mov ax, es
  add ax, 0040h
  mov es, ax
  mov ax, word [data_00000007]
  inc ax
  mov word [data_00000007], ax
  cmp ax, 0010h
  jz label_0000008f ; 16 times (16384)
  mov al, byte [data_00000006]
  inc al
  mov byte [data_00000006], al
  cmp al, 09h
  jnz label_0000003f
  mov byte [data_00000006], 01h
  mov al, byte [data_00000005]
  inc al
  and al, 01h
  mov byte [data_00000005], al
  jnz label_0000003f
  inc byte [data_00000004]
  jmp short label_0000003f
label_0000008f:
  jmp DESTINATIONSEG:DESTINATIONOFS