#include "idxalloc.h"

#include <stdlib.h>

unsigned char idxinit(struct idxalloc* ial, unsigned int numidx) {
  unsigned int* arr = malloc(sizeof(unsigned int) * numidx);
  ial->array = arr;
  ial->lastunused = numidx - 1;
  ial->numused = 0;
  if (arr != NULL) {
    ial->arraysize = numidx;
    for (unsigned int idx = 0; idx + 1 < numidx; ++idx) {
      ial->array[idx] = idx + 1;
    }
    ial->array[numidx - 1] = 0;
  } else {
    ial->arraysize = 0;
  }
  return (arr != NULL);
}

unsigned int idxgetnew(struct idxalloc* ial) {
  unsigned int newidx = ial->array[ial->lastunused];
  ial->array[ial->lastunused] = ial->array[newidx];
  ial->array[newidx] = (unsigned int)-1;
  if (++ial->numused == ial->arraysize) {
    unsigned int* newarr = realloc(ial->array, sizeof(unsigned int) * (ial->arraysize * 2));
    if (newarr != NULL) {
      ial->array = newarr;
      ial->lastunused = ial->arraysize * 2 - 1;
      for (unsigned int idx = ial->arraysize; idx + 1 < ial->arraysize * 2; ++idx) {
        ial->array[idx] = idx + 1;
      }
       ial->array[ial->arraysize * 2 - 1] = ial->arraysize;
      ial->arraysize = ial->arraysize * 2;
    }
  }
  return newidx;
}

void idxremove(struct idxalloc* ial, unsigned int idx) {
  if (ial->array[idx] == (unsigned int)-1) {
    --ial->numused;
    ial->array[idx] = ial->array[ial->lastunused];
    ial->array[ial->lastunused] = idx;
    ial->lastunused = idx;
  }
}

void idxclear(struct idxalloc* ial) {
  for (unsigned int idx = 0; idx + 1 < ial->arraysize; ++idx) {
    ial->array[idx] = idx + 1;
  }
  ial->array[ial->arraysize - 1] = 0;
  ial->lastunused = ial->arraysize - 1;
}

unsigned char idxcheckalloc(struct idxalloc* ial, unsigned int idx) {
  return ial->array[idx] == (unsigned int)-1;
}